searchNodes=[{"ref":"Ash.html","title":"Ash","type":"module","doc":"The primary interface for interrogating apis and resources. These are tools for interrogating resources to derive behavior based on their configuration. This is how all of the behavior of Ash is ultimately configured."},{"ref":"Ash.html#action/3","title":"Ash.action/3","type":"function","doc":"Returns the action with the matching name and type on the resource"},{"ref":"Ash.html#actions/1","title":"Ash.actions/1","type":"function","doc":"A list of all actions on the resource"},{"ref":"Ash.html#attribute/2","title":"Ash.attribute/2","type":"function","doc":"Get an attribute name from the resource"},{"ref":"Ash.html#attributes/1","title":"Ash.attributes/1","type":"function","doc":"A list of all attributes on the resource"},{"ref":"Ash.html#authorizers/1","title":"Ash.authorizers/1","type":"function","doc":"A list of authorizers to be used when accessing the resource"},{"ref":"Ash.html#data_layer/1","title":"Ash.data_layer/1","type":"function","doc":"The data layer of the resource, or nil if it does not have one"},{"ref":"Ash.html#describe/1","title":"Ash.describe/1","type":"function","doc":"A short description of the resource, to be included in autogenerated documentation"},{"ref":"Ash.html#name/1","title":"Ash.name/1","type":"function","doc":"The name of the resource, e.g &#39;posts&#39;"},{"ref":"Ash.html#primary_action/2","title":"Ash.primary_action/2","type":"function","doc":"Returns the primary action of a given type for a resource"},{"ref":"Ash.html#primary_key/1","title":"Ash.primary_key/1","type":"function","doc":"A list of field names corresponding to the primary key of a resource"},{"ref":"Ash.html#relationship/2","title":"Ash.relationship/2","type":"function","doc":"Gets a relationship by name from the resource"},{"ref":"Ash.html#relationships/1","title":"Ash.relationships/1","type":"function","doc":"A list of relationships on the resource"},{"ref":"Ash.html#resources/1","title":"Ash.resources/1","type":"function","doc":"A list of resource modules for a given API"},{"ref":"Ash.html#type/1","title":"Ash.type/1","type":"function","doc":"The type of the resource, e.g &#39;post&#39;"},{"ref":"Ash.html#t:action/0","title":"Ash.action/0","type":"type","doc":""},{"ref":"Ash.html#t:actor/0","title":"Ash.actor/0","type":"type","doc":""},{"ref":"Ash.html#t:api/0","title":"Ash.api/0","type":"type","doc":""},{"ref":"Ash.html#t:attribute/0","title":"Ash.attribute/0","type":"type","doc":""},{"ref":"Ash.html#t:cardinality_many_relationship/0","title":"Ash.cardinality_many_relationship/0","type":"type","doc":""},{"ref":"Ash.html#t:cardinality_one_relationship/0","title":"Ash.cardinality_one_relationship/0","type":"type","doc":""},{"ref":"Ash.html#t:data_layer/0","title":"Ash.data_layer/0","type":"type","doc":""},{"ref":"Ash.html#t:data_layer_query/0","title":"Ash.data_layer_query/0","type":"type","doc":""},{"ref":"Ash.html#t:error/0","title":"Ash.error/0","type":"type","doc":""},{"ref":"Ash.html#t:filter/0","title":"Ash.filter/0","type":"type","doc":""},{"ref":"Ash.html#t:params/0","title":"Ash.params/0","type":"type","doc":""},{"ref":"Ash.html#t:query/0","title":"Ash.query/0","type":"type","doc":""},{"ref":"Ash.html#t:record/0","title":"Ash.record/0","type":"type","doc":""},{"ref":"Ash.html#t:relationship/0","title":"Ash.relationship/0","type":"type","doc":""},{"ref":"Ash.html#t:relationship_cardinality/0","title":"Ash.relationship_cardinality/0","type":"type","doc":""},{"ref":"Ash.html#t:resource/0","title":"Ash.resource/0","type":"type","doc":""},{"ref":"Ash.html#t:side_loads/0","title":"Ash.side_loads/0","type":"type","doc":""},{"ref":"Ash.html#t:sort/0","title":"Ash.sort/0","type":"type","doc":""},{"ref":"Ash.Api.html","title":"Ash.Api","type":"module","doc":"An Api allows you to interact with your resources, anc holds non-resource-specific configuration. Your Api can also house config that is not resource specific. Defining a resource won&#39;t do much for you. Once you have some resources defined, you include them in an Api like so: defmodule MyApp.Api do use Ash.Api resources [OneResource, SecondResource] end Then you can interact through that Api with the actions that those resources expose. For example: MyApp.Api.create(OneResource, %{attributes: %{name: &quot;thing&quot;}}), or MyApp.Api.read(query). Corresponding actions must be defined in your resources in order to call them through the Api."},{"ref":"Ash.Api.html#resources/1","title":"Ash.Api.resources/1","type":"macro","doc":""},{"ref":"Ash.DataLayer.html","title":"Ash.DataLayer","type":"behaviour","doc":"The interface for being an ash data layer. Typically this will be provided by an extension, but you could implement one yourself and add it to your resource with @data_layer YourDataLayer This is a large behaviour, and this capability is not complete, but the idea is to have a large amount of optional callbacks, and use the can?/2 callback to ensure that the engine only ever tries to interact with the data layer in ways that it supports."},{"ref":"Ash.DataLayer.html#can?/2","title":"Ash.DataLayer.can?/2","type":"function","doc":""},{"ref":"Ash.DataLayer.html#c:can?/2","title":"Ash.DataLayer.can?/2","type":"callback","doc":""},{"ref":"Ash.DataLayer.html#c:can_query_async?/1","title":"Ash.DataLayer.can_query_async?/1","type":"callback","doc":""},{"ref":"Ash.DataLayer.html#create/2","title":"Ash.DataLayer.create/2","type":"function","doc":""},{"ref":"Ash.DataLayer.html#c:create/2","title":"Ash.DataLayer.create/2","type":"callback","doc":""},{"ref":"Ash.DataLayer.html#custom_filters/1","title":"Ash.DataLayer.custom_filters/1","type":"function","doc":""},{"ref":"Ash.DataLayer.html#c:custom_filters/1","title":"Ash.DataLayer.custom_filters/1","type":"callback","doc":""},{"ref":"Ash.DataLayer.html#c:destroy/1","title":"Ash.DataLayer.destroy/1","type":"callback","doc":""},{"ref":"Ash.DataLayer.html#filter/3","title":"Ash.DataLayer.filter/3","type":"function","doc":""},{"ref":"Ash.DataLayer.html#c:filter/3","title":"Ash.DataLayer.filter/3","type":"callback","doc":""},{"ref":"Ash.DataLayer.html#limit/3","title":"Ash.DataLayer.limit/3","type":"function","doc":""},{"ref":"Ash.DataLayer.html#c:limit/3","title":"Ash.DataLayer.limit/3","type":"callback","doc":""},{"ref":"Ash.DataLayer.html#offset/3","title":"Ash.DataLayer.offset/3","type":"function","doc":""},{"ref":"Ash.DataLayer.html#c:offset/3","title":"Ash.DataLayer.offset/3","type":"callback","doc":""},{"ref":"Ash.DataLayer.html#resource_to_query/1","title":"Ash.DataLayer.resource_to_query/1","type":"function","doc":""},{"ref":"Ash.DataLayer.html#c:resource_to_query/1","title":"Ash.DataLayer.resource_to_query/1","type":"callback","doc":""},{"ref":"Ash.DataLayer.html#run_query/2","title":"Ash.DataLayer.run_query/2","type":"function","doc":""},{"ref":"Ash.DataLayer.html#c:run_query/2","title":"Ash.DataLayer.run_query/2","type":"callback","doc":""},{"ref":"Ash.DataLayer.html#sort/3","title":"Ash.DataLayer.sort/3","type":"function","doc":""},{"ref":"Ash.DataLayer.html#c:sort/3","title":"Ash.DataLayer.sort/3","type":"callback","doc":""},{"ref":"Ash.DataLayer.html#transact/2","title":"Ash.DataLayer.transact/2","type":"function","doc":""},{"ref":"Ash.DataLayer.html#c:transaction/2","title":"Ash.DataLayer.transaction/2","type":"callback","doc":""},{"ref":"Ash.DataLayer.html#update/2","title":"Ash.DataLayer.update/2","type":"function","doc":""},{"ref":"Ash.DataLayer.html#c:update/2","title":"Ash.DataLayer.update/2","type":"callback","doc":""},{"ref":"Ash.DataLayer.html#upsert/2","title":"Ash.DataLayer.upsert/2","type":"function","doc":""},{"ref":"Ash.DataLayer.html#c:upsert/2","title":"Ash.DataLayer.upsert/2","type":"callback","doc":""},{"ref":"Ash.DataLayer.html#t:feature/0","title":"Ash.DataLayer.feature/0","type":"type","doc":""},{"ref":"Ash.DataLayer.html#t:filter_type/0","title":"Ash.DataLayer.filter_type/0","type":"type","doc":""},{"ref":"Ash.DataLayer.Ets.html","title":"Ash.DataLayer.Ets","type":"behaviour","doc":"An ETS (Erlang Term Storage) backed Ash Datalayer, for testing. This is used for testing. Do not use this data layer in production"},{"ref":"Ash.DataLayer.Ets.html#c:ets_private?/0","title":"Ash.DataLayer.Ets.ets_private?/0","type":"callback","doc":""},{"ref":"Ash.DataLayer.Ets.html#private?/1","title":"Ash.DataLayer.Ets.private?/1","type":"function","doc":""},{"ref":"Ash.Engine.Authorizer.html","title":"Ash.Engine.Authorizer","type":"behaviour","doc":"The interface for an ash authorizer These will typically be implemented by an extension, but a custom one can be implemented by defining a module that adopts this behaviour and using @authorizers YourAuthorizer to your resource."},{"ref":"Ash.Engine.Authorizer.html#c:check/2","title":"Ash.Engine.Authorizer.check/2","type":"callback","doc":""},{"ref":"Ash.Engine.Authorizer.html#check/3","title":"Ash.Engine.Authorizer.check/3","type":"function","doc":""},{"ref":"Ash.Engine.Authorizer.html#c:check_context/1","title":"Ash.Engine.Authorizer.check_context/1","type":"callback","doc":""},{"ref":"Ash.Engine.Authorizer.html#check_context/2","title":"Ash.Engine.Authorizer.check_context/2","type":"function","doc":""},{"ref":"Ash.Engine.Authorizer.html#c:initial_state/4","title":"Ash.Engine.Authorizer.initial_state/4","type":"callback","doc":""},{"ref":"Ash.Engine.Authorizer.html#initial_state/5","title":"Ash.Engine.Authorizer.initial_state/5","type":"function","doc":""},{"ref":"Ash.Engine.Authorizer.html#c:strict_check/2","title":"Ash.Engine.Authorizer.strict_check/2","type":"callback","doc":""},{"ref":"Ash.Engine.Authorizer.html#strict_check/3","title":"Ash.Engine.Authorizer.strict_check/3","type":"function","doc":""},{"ref":"Ash.Engine.Authorizer.html#c:strict_check_context/1","title":"Ash.Engine.Authorizer.strict_check_context/1","type":"callback","doc":""},{"ref":"Ash.Engine.Authorizer.html#strict_check_context/2","title":"Ash.Engine.Authorizer.strict_check_context/2","type":"function","doc":""},{"ref":"Ash.Engine.Authorizer.html#t:context/0","title":"Ash.Engine.Authorizer.context/0","type":"type","doc":""},{"ref":"Ash.Engine.Authorizer.html#t:state/0","title":"Ash.Engine.Authorizer.state/0","type":"type","doc":""},{"ref":"Ash.Error.ApiDslError.html","title":"Ash.Error.ApiDslError","type":"exception","doc":"Used when api&#39;s DSL is incorrectly configured."},{"ref":"Ash.Error.Changes.InvalidValue.html","title":"Ash.Error.Changes.InvalidValue","type":"exception","doc":"Used when an invalid value is provided for a change"},{"ref":"Ash.Error.Changes.UnknownError.html","title":"Ash.Error.Changes.UnknownError","type":"exception","doc":"Used when a change fails for an unknown reason"},{"ref":"Ash.Error.Filter.InvalidFilterValue.html","title":"Ash.Error.Filter.InvalidFilterValue","type":"exception","doc":"Used when an invalid value is provided for a filter"},{"ref":"Ash.Error.Forbidden.html","title":"Ash.Error.Forbidden","type":"exception","doc":"Used when authorization for an action fails"},{"ref":"Ash.Error.Framework.html","title":"Ash.Error.Framework","type":"exception","doc":"Used when an unknown/generic framework error occurs"},{"ref":"Ash.Error.FrameworkError.html","title":"Ash.Error.FrameworkError","type":"exception","doc":"Used when an internal framework error occurs. These are always bugs."},{"ref":"Ash.Error.Interface.NoSuchResource.html","title":"Ash.Error.Interface.NoSuchResource","type":"exception","doc":"Used when a resource or alias is provided that doesn&#39;t exist"},{"ref":"Ash.Error.Invalid.html","title":"Ash.Error.Invalid","type":"exception","doc":"The top level invalid error"},{"ref":"Ash.Error.InvalidLimit.html","title":"Ash.Error.InvalidLimit","type":"exception","doc":"Used when an invalid limit is provided"},{"ref":"Ash.Error.InvalidOffset.html","title":"Ash.Error.InvalidOffset","type":"exception","doc":"Used when an invalid offset is provided"},{"ref":"Ash.Error.ResourceDslError.html","title":"Ash.Error.ResourceDslError","type":"exception","doc":"Used when a resource&#39;s DSL is incorrectly configured."},{"ref":"Ash.Error.SideLoad.InvalidQuery.html","title":"Ash.Error.SideLoad.InvalidQuery","type":"exception","doc":"Used when an invalid query is provided in a side load"},{"ref":"Ash.Error.SideLoad.NoSuchRelationship.html","title":"Ash.Error.SideLoad.NoSuchRelationship","type":"exception","doc":"Used when attempting to side load a relationship that does not exist"},{"ref":"Ash.Error.Sort.InvalidSortOrder.html","title":"Ash.Error.Sort.InvalidSortOrder","type":"exception","doc":"Used when an invalid sort order is provided"},{"ref":"Ash.Error.Sort.NoSuchField.html","title":"Ash.Error.Sort.NoSuchField","type":"exception","doc":"Used when attempting to sort on a field that does not exist"},{"ref":"Ash.Error.Sort.UnsortableField.html","title":"Ash.Error.Sort.UnsortableField","type":"exception","doc":"Used when attempting to sort on a field that cannot be used for sorting"},{"ref":"Ash.Error.Unknown.html","title":"Ash.Error.Unknown","type":"exception","doc":"The top level unknown error container"},{"ref":"Ash.Query.html","title":"Ash.Query","type":"module","doc":"Utilties around constructing/manipulating ash queries. Ash queries are used for read actions and side loads, and ultimately map to queries to a resource&#39;s data layer."},{"ref":"Ash.Query.html#do_validate_side_load/3","title":"Ash.Query.do_validate_side_load/3","type":"function","doc":""},{"ref":"Ash.Query.html#filter/2","title":"Ash.Query.filter/2","type":"function","doc":""},{"ref":"Ash.Query.html#limit/2","title":"Ash.Query.limit/2","type":"function","doc":""},{"ref":"Ash.Query.html#merge_side_load/2","title":"Ash.Query.merge_side_load/2","type":"function","doc":""},{"ref":"Ash.Query.html#offset/2","title":"Ash.Query.offset/2","type":"function","doc":""},{"ref":"Ash.Query.html#reject/2","title":"Ash.Query.reject/2","type":"function","doc":""},{"ref":"Ash.Query.html#side_load/2","title":"Ash.Query.side_load/2","type":"function","doc":""},{"ref":"Ash.Query.html#sort/2","title":"Ash.Query.sort/2","type":"function","doc":""},{"ref":"Ash.Query.html#unset/2","title":"Ash.Query.unset/2","type":"function","doc":""},{"ref":"Ash.Query.html#validate_side_load/3","title":"Ash.Query.validate_side_load/3","type":"function","doc":""},{"ref":"Ash.Query.html#t:t/0","title":"Ash.Query.t/0","type":"type","doc":""},{"ref":"Ash.Resource.html","title":"Ash.Resource","type":"behaviour","doc":"A resource is a static definition of an entity in your system. Resource DSL documentation: Ash.Resource.DSL The following options apply to use Ash.Resource, [...] :name - Required. The name of the resource, e.g posts or authors. This will typically be the pluralized form of the type :type - Required. The type of the resource, e.g post or author. This is used throughout the system. For more information on the resource DSL, see Ash.Resource.DSL Note: Do not call the functions on a resource, as in MyResource.type() as this is a private API and can change at any time. Instead, use the Ash module, for example: Ash.type(MyResource)"},{"ref":"Ash.Resource.html#c:actions/0","title":"Ash.Resource.actions/0","type":"callback","doc":"A list of actions available for the resource"},{"ref":"Ash.Resource.html#c:attributes/0","title":"Ash.Resource.attributes/0","type":"callback","doc":"A list of attributes on the resource"},{"ref":"Ash.Resource.html#c:authorizers/0","title":"Ash.Resource.authorizers/0","type":"callback","doc":"A list of authorizers to be used when accessing the resource"},{"ref":"Ash.Resource.html#c:data_layer/0","title":"Ash.Resource.data_layer/0","type":"callback","doc":"The data_layer in use by the resource, or nil if there is not one"},{"ref":"Ash.Resource.html#c:describe/0","title":"Ash.Resource.describe/0","type":"callback","doc":"A description of the resource, to be showed in generated documentation"},{"ref":"Ash.Resource.html#c:extensions/0","title":"Ash.Resource.extensions/0","type":"callback","doc":"A list of extensions implemented by the resource"},{"ref":"Ash.Resource.html#c:name/0","title":"Ash.Resource.name/0","type":"callback","doc":"The name of the resource, e.g &#39;posts&#39;"},{"ref":"Ash.Resource.html#c:primary_key/0","title":"Ash.Resource.primary_key/0","type":"callback","doc":"A list of attribute names that make up the primary key, e.g [:class, :group]"},{"ref":"Ash.Resource.html#c:relationships/0","title":"Ash.Resource.relationships/0","type":"callback","doc":"A list of relationships to other resources"},{"ref":"Ash.Resource.html#c:type/0","title":"Ash.Resource.type/0","type":"callback","doc":"The type of the resource, e.g &#39;post&#39;"},{"ref":"Ash.Resource.Actions.html","title":"Ash.Resource.Actions","type":"module","doc":"DSL components for declaring resource actions. All manipulation of data through the underlying data layer happens through actions. There are four types of action: create, read, update, and destroy. You may recognize these from the acronym CRUD. You can have multiple actions of the same type, as long as they have different names. This is the primary mechanism for customizing your resources to conform to your business logic. It is normal and expected to have multiple actions of each type in a large application. If you have multiple actions of the same type, one of them must be designated as the primary action for that type, via: primary?: true. This tells the ash what to do if an action of that type is requested, but no specific action name is given."},{"ref":"Ash.Resource.Actions.html#create/2","title":"Ash.Resource.Actions.create/2","type":"macro","doc":"Declares a create action. For calling this action, see the Ash.Api documentation. :primary? - Whether or not this action should be used when no action is specified by the caller. The default value is false. Examples create :register, primary?: true"},{"ref":"Ash.Resource.Actions.html#destroy/2","title":"Ash.Resource.Actions.destroy/2","type":"macro","doc":"Declares an destroy action. For calling this action, see the Ash.Api documentation. :primary? - Whether or not this action should be used when no action is specified by the caller. The default value is false. Examples destroy :soft_delete, primary?: true"},{"ref":"Ash.Resource.Actions.html#read/2","title":"Ash.Resource.Actions.read/2","type":"macro","doc":"Declares a read action. For calling this action, see the Ash.Api documentation. :primary? - Whether or not this action should be used when no action is specified by the caller. The default value is false. Examples read :read_all, primary?: true"},{"ref":"Ash.Resource.Actions.html#update/2","title":"Ash.Resource.Actions.update/2","type":"macro","doc":"Declares an update action. For calling this action, see the Ash.Api documentation. :primary? - Whether or not this action should be used when no action is specified by the caller. The default value is false. Examples update :flag_for_review, primary?: true"},{"ref":"Ash.Resource.Actions.Read.html","title":"Ash.Resource.Actions.Read","type":"module","doc":"The representation of a read action"},{"ref":"Ash.Resource.Actions.Read.html#new/3","title":"Ash.Resource.Actions.Read.new/3","type":"function","doc":""},{"ref":"Ash.Resource.Actions.Read.html#t:t/0","title":"Ash.Resource.Actions.Read.t/0","type":"type","doc":""},{"ref":"Ash.Resource.Attributes.html","title":"Ash.Resource.Attributes","type":"module","doc":"A DSL component for declaring attributes Attributes are fields on an instance of a resource. The two required pieces of knowledge are the field name, and the type."},{"ref":"Ash.Resource.Attributes.html#attribute/3","title":"Ash.Resource.Attributes.attribute/3","type":"macro","doc":"Declares an attribute on the resource Type can be either a built in type (see Ash.Type) for more, or a module implementing the Ash.Type behaviour. :primary_key? - Whether or not the attribute is part of the primary key (one or more fields that uniquely identify a resource) The default value is false. :allow_nil? - Whether or not the attribute can be set to nil The default value is true. :generated? - Whether or not the value may be generated by the data layer The default value is false. :writable? - Whether or not the value can be written to The default value is true. :update_default - A zero argument function, an {mod, fun, args} triple or {:constant, value}. If no value is provided for the attribute on update, this value is used. :default - A zero argument function, an {mod, fun, args} triple or {:constant, value}. If no value is provided for the attribute on create, this value is used. Examples attribute :first_name, :string, primary_key?: true"},{"ref":"Ash.Resource.Attributes.html#timestamps/1","title":"Ash.Resource.Attributes.timestamps/1","type":"macro","doc":"Adds auto updating timestamp fields The field names default to :inserted_at and :updated_at, but can be overwritten via passing overrides in the opts, e.g timestamps(inserted_at: :created_at, updated_at: :last_touched) :inserted_at_field - The name to use for the inserted at field The default value is :inserted_at. :updated_at_field - The name to use for the updated at field The default value is :updated_at. Examples attribute :first_name, :string, primary_key?: true"},{"ref":"Ash.Resource.DSL.html","title":"Ash.Resource.DSL","type":"module","doc":"The entrypoint for the Ash DSL documentation and interface. Available DSL sections: actions - Ash.Resource.Actions attributes - Ash.Resource.Attributes relationships - Ash.Resource.Relationships See the relevant module documentation. To use sections in your resource: defmodule MyModule do use Ash.Resource, name: &quot;foos&quot;, type: &quot;foo&quot; actions do ... # see actions documentation end attributes do ... # see attributes documentation end relationships do ... # see relationships documentation end end"},{"ref":"Ash.Resource.Relationships.html","title":"Ash.Resource.Relationships","type":"module","doc":"DSL components for declaring relationships. Relationships are a core component of resource oriented design. Many components of Ash will use these relationships. A simple use case is side_loading (done via the side_load option, given to an api action)."},{"ref":"Ash.Resource.Relationships.html#belongs_to/3","title":"Ash.Resource.Relationships.belongs_to/3","type":"macro","doc":"Declares a belongs_to relationship. In a relational database, the foreign key would be on the source table. This creates a field on the resource with the corresponding name, unless define_field?: false is provided. Practically speaking, a belongs_to and a has_one are interchangable in every way. :destination_field - The field on the related resource that should match the source_field on this resource. The default value is :id. :source_field - The field on this resource that should match the destination_field on the related resource. Default: [relationship_name]_id :primary_key? - Whether this field is, or is part of, the primary key of a resource. The default value is false. :define_field? - If set to false a field is not created on the resource for this relationship, and one must be manually added in attributes. The default value is true. :field_type - The field type of the automatically created field. The default value is :uuid. :reverse_relationship - A requirement for side loading data. Must be the name of an inverse relationship on the destination resource. Examples # In a resource called `Word` belongs_to :dictionary_entry, DictionaryEntry, source_field: :text, destination_field: :word_text"},{"ref":"Ash.Resource.Relationships.html#has_many/3","title":"Ash.Resource.Relationships.has_many/3","type":"macro","doc":"Declares a has_many relationship. There can be any number of related entities. :destination_field - The field on the related resource that should match the source_field on this resource. Default: [resource.name]_id :source_field - The field on this resource that should match the destination_field on the related resource. The default value is :id. :reverse_relationship - A requirement for side loading data. Must be the name of an inverse relationship on the destination resource. Examples # In a resource called `Word` has_many :definitions, DictionaryDefinition, source_field: :text, destination_field: :word_text"},{"ref":"Ash.Resource.Relationships.html#has_one/3","title":"Ash.Resource.Relationships.has_one/3","type":"macro","doc":"Declares a has_one relationship. In a relationsal database, the foreign key would be on the other table. Generally speaking, a has_one also implies that the destination table is unique on that foreign key. Practically speaking, a has_one and a belongs_to are interchangable in every way. :destination_field - The field on the related resource that should match the source_field on this resource. Default: [resource.name]_id :source_field - The field on this resource that should match the destination_field on the related resource. The default value is :id. :reverse_relationship - A requirement for side loading data. Must be the name of an inverse relationship on the destination resource. Examples # In a resource called `Word` has_one :dictionary_entry, DictionaryEntry, source_field: :text, destination_field: :word_text"},{"ref":"Ash.Resource.Relationships.html#many_to_many/3","title":"Ash.Resource.Relationships.many_to_many/3","type":"macro","doc":"Declares a many_to_many relationship. Many to many relationships require a join table. A join table is typically a table who&#39;s primary key consists of one foreign key to each resource. You can specify a join table as a string or as another resource. :source_field_on_join_table - The field on the join table that should line up with source_field on this resource. Default: [resource_name]_id :destination_field_on_join_table - The field on the join table that should line up with destination_field on the related resource. Default: [relationshihp_name]_id :source_field - The field on this resource that should line up with source_field_on_join_table on the join table. The default value is :id. :destination_field - The field on the related resource that should line up with destination_field_on_join_table on the join table. The default value is :id. :through - Required. The resource to use as the join resource. :reverse_relationship - A requirement for side loading data. Must be the name of an inverse relationship on the destination resource. Examples # In a resource called `Word` many_to_many :books, Book, through: BookWord, source_field: :text, source_field_on_join_table: :word_text, destination_field: :id, destination_field_on_join_table: :book_id"},{"ref":"Ash.Resource.Relationships.html#maybe_define_attribute/2","title":"Ash.Resource.Relationships.maybe_define_attribute/2","type":"macro","doc":""},{"ref":"Ash.Type.html","title":"Ash.Type","type":"behaviour","doc":"This behaviour is a superset of the Ecto.Type behavior, that also contains api level information, like what kinds of filters are allowed. Eventually, this may be used for composite types or serialization. Much better to use Ash.Type than to say @behaviour Ash.Type and define everything yourself."},{"ref":"Ash.Type.html#ash_type?/1","title":"Ash.Type.ash_type?/1","type":"function","doc":"Returns true if the value is a builtin type or adopts the Ash.Type behaviour"},{"ref":"Ash.Type.html#builtins/0","title":"Ash.Type.builtins/0","type":"function","doc":"A list of the built in type names"},{"ref":"Ash.Type.html#c:cast_input/1","title":"Ash.Type.cast_input/1","type":"callback","doc":""},{"ref":"Ash.Type.html#cast_input/2","title":"Ash.Type.cast_input/2","type":"function","doc":"Casts input (e.g. unknown) data to an instance of the type, or errors Maps to Ecto.Type.cast/2"},{"ref":"Ash.Type.html#c:cast_stored/1","title":"Ash.Type.cast_stored/1","type":"callback","doc":""},{"ref":"Ash.Type.html#cast_stored/2","title":"Ash.Type.cast_stored/2","type":"function","doc":"Casts a value from the data store to an instance of the type, or errors Maps to Ecto.Type.load/2"},{"ref":"Ash.Type.html#c:describe/0","title":"Ash.Type.describe/0","type":"callback","doc":""},{"ref":"Ash.Type.html#c:dump_to_native/1","title":"Ash.Type.dump_to_native/1","type":"callback","doc":""},{"ref":"Ash.Type.html#dump_to_native/2","title":"Ash.Type.dump_to_native/2","type":"function","doc":"Casts a value from the Elixir type to a value that the data store can persist Maps to Ecto.Type.dump/2"},{"ref":"Ash.Type.html#c:ecto_type/0","title":"Ash.Type.ecto_type/0","type":"callback","doc":""},{"ref":"Ash.Type.html#ecto_type/1","title":"Ash.Type.ecto_type/1","type":"function","doc":"Returns the ecto compatible type for an Ash.Type. If you use Ash.Type, this is created for you. For builtin types this may return a corresponding ecto builtin type (atom)"},{"ref":"Ash.Type.html#c:equal?/2","title":"Ash.Type.equal?/2","type":"callback","doc":""},{"ref":"Ash.Type.html#equal?/3","title":"Ash.Type.equal?/3","type":"function","doc":"Determines if two values of a given type are equal. Maps to Ecto.Type.equal?/3"},{"ref":"Ash.Type.html#get_type/1","title":"Ash.Type.get_type/1","type":"function","doc":""},{"ref":"Ash.Type.html#c:sortable?/1","title":"Ash.Type.sortable?/1","type":"callback","doc":""},{"ref":"Ash.Type.html#sortable?/2","title":"Ash.Type.sortable?/2","type":"function","doc":"Determines whether or not this value can be sorted."},{"ref":"Ash.Type.html#c:storage_type/0","title":"Ash.Type.storage_type/0","type":"callback","doc":""},{"ref":"Ash.Type.html#storage_type/1","title":"Ash.Type.storage_type/1","type":"function","doc":"Returns the underlying storage type (the underlying type of the ecto type of the ash type)"},{"ref":"Ash.Type.html#c:supported_filter_types/1","title":"Ash.Type.supported_filter_types/1","type":"callback","doc":""},{"ref":"Ash.Type.html#supports_filter?/4","title":"Ash.Type.supports_filter?/4","type":"function","doc":""},{"ref":"Ash.Type.html#t:t/0","title":"Ash.Type.t/0","type":"type","doc":""},{"ref":"Ash.Type.Atom.html","title":"Ash.Type.Atom","type":"module","doc":"A type used for storing atoms. For safety reasons, it uses String.to_existing_atom/1, which means that the atom should exist in your application before reading a record with that atom."},{"ref":"Ash.Type.Term.html","title":"Ash.Type.Term","type":"module","doc":"Stores a raw elixir term in the database"},{"ref":"readme.html","title":"README","type":"extras","doc":""},{"ref":"readme.html#quick-links","title":"README - Quick Links","type":"extras","doc":"Resource Documentation DSL Documentation Code API documentation"},{"ref":"readme.html#introduction","title":"README - Introduction","type":"extras","doc":"Traditional MVC Frameworks (Rails, Django, .Net, Phoenix, etc) leave it up to the user to build the glue between requests for data (HTTP requests in various forms as well as server-side domain logic) and their respective ORMs. In that space, there is an incredible amount of boilerplate code that must get written from scratch for each application (authentication, authorization, sorting, filtering, sideloading relationships, serialization, etc). Ash is an opinionated yet configurable framework designed to reduce boilerplate in an Elixir application. Ash does this by providing a layer of abstraction over your system&#39;s data layer(s) with Resources. It is designed to be used in conjunction with a phoenix application, or on its own. To riff on a famous JRR Tolkien quote, a Resourceis &quot;One Interface to rule them all, One Interface to find them&quot; and will become an indispensable place to define contracts for interacting with data throughout your application. To start using Ash, first declare your Resources using the Ash Resource DSL. You could technically stop there, and just leverage the Ash Elixir API to avoid writing boilerplate. More likely, you would use extensions like Ash.JsonApi or Ash.GraphQL with Phoenix to add external interfaces to those resources without having to write any extra code at all. Ash is an open-source project and draws inspiration from similar ideas in other frameworks and concepts. The goal of Ash is to lower the barrier to adopting and using Elixir and Phoenix, and in doing so help these amazing communities attract new developers, projects, and companies."},{"ref":"readme.html#example-resource","title":"README - Example Resource","type":"extras","doc":"defmodule Post do use Ash.Resource, name: &quot;posts&quot;, type: &quot;post&quot; use AshJsonApi.JsonApiResource use Ash.DataLayer.Postgres actions do read :default create :default end attributes do attribute :name, :string end relationships do belongs_to :author, Author end end"},{"ref":"readme.html#todo-list-in-no-order","title":"README - TODO LIST (in no order)","type":"extras","doc":"Code Organization break up the Ash module consider moving type and name for resources out into json api (or perhaps just name) since only json api uses that Consider allowing declaring a data layer at the api level, or overriding the resource&#39;s data layer at the api level document the interface Errors Wire up/formalize the error handling (this is high priority) Ensure that errors are properly propagated up from the data_layer behaviour, and every operation is allowed to fail includer errors are super obscure because you can&#39;t tell what action they are about Filters Make sure to segment filters based on the involved data layers, so we can support cross data-layer filtering Add impossibility checking for filters to avoid running queries that will never be possible. Validate filters, now that there can be duplicates. Doesn&#39;t make sense to provide two &quot;exact equals&quot; filters Clean up and test filter inspecting code. When checking for filter inclusion, we should allow for and filters to each contain part of the filter, requiring that the whole thing is covered by all of the ands at least Add filter: [relationship_name: [all: [...filter...]]] so you can assert that all related items match a filter (for to many relationships, may perform poorly) really need to figure out the distinction between filter impossibility for things like authorization plays into filter impossibility as an optimization. I think they are actually two different things. The fact that you consider nothing to be a subset of an impossible filter may not be correct. Figure out how to handle cross data layer filters for boolean. lift or filters over the same field equaling a value into a single in filter, for performance (potentially) make runtime filtering of a list of records + an ash filter a public interface. At first, we can just run a query with that filter, and filter for matches. Eventually it can be optimized. When combining filters, we can prune branches that are strict subset of eachother potentially. Depends on the performance of the sat solver. Perhaps the best choice there would be to traverse on each filter addition, perhaps using the existing Merge entrypoint ? document the concepts behind filter simplification. The following is an old comment I wrote talking about it # The story here: # we don&#39;t really need to fully simplify every value statement, e.g `in: [1, 2, 3]` -&gt; `== 1 or == 2 or == 3` # We could instead just simplify *only as much as we need to*, for instance if the filter contains # `in: [1, 2, 3]` and `in: [2, 3, 4]`, we could translate the first to `in: [2, 3] or == 1` and the # second one to `in: [2, 3] or == 4`. We should then be able to go about expressing the fact that none # of `== 1` and `== 2` are mutually exclusive terms by exchanging them for `== 1 and != 2` and `== 2 and != 1` # respectively. This is the methodology behind translating a *value* based filter into a boolean expression. # # However for now for simplicity&#39;s sake, I&#39;m turning all `in: [1, 2]` into `== 1 or == 2` and all `not_in: [1, 2]` # into `!= 1 and !=2` for the sole reason that its not worth figuring it out right now. Cosimplification is, at the # and of the day, really just an optimization to keep the expression simple. Its not so important with lists and equality # but when we add substring filters/greater than filters, we&#39;re going to need to improve this logic This is from a conversation about how we might support on-demand calculated attributes that would allow doing something like getting the trigram similarity to a piece of text and filtering on it in the same request :representatives |&gt; Api.query() |&gt; Ash.Query.filter(first_name: [trigram: [text: &quot;Geoff&quot;, similarity: [greater_than: 0.1]]]) |&gt; Api.read!() calculated_attributes do on_demand :trigram, [:first_name, :last_name] # calculated(:name_similarity, :float, calculate: [trigram_similarity: {:input, :text}]) end :representatives |&gt; Api.query() |&gt; Ash.Query.calculate(first_name_similarity: [first_name: [trigram: [text: &quot;Geoff&quot;]]]) |&gt; Ash.Query.filter(first_name_similarity: [greater_than: 0.1]) |&gt; Api.read!() Actions all actions need to be performed in a transaction Since actions can return multiple errors, we need a testing utility to unwrap/assert on them Validate that checks have the correct action type when compiling an action Handle related values on delete If structs/a struct is passed into a relationship change like api.update(:author, relationships: %{posts: %Post{}}) we shouldn&#39;t have to read it back Support bulk creation - use this when managing to many relationships if available support deleting w/ a query - use this when managing to many relationships Support fields on join tables if they are a resource dont require a join table for many_to_many relationships Authorization document authorization thoroughly. batch (default) checks need to return a list of ids for which the check passed. Do branch analysis of each record after authorizing it, in authorizer Make authorization spit out informative errors (at least for developers) Rearchitect relationship updates so that they can be sensible authorized. As in, which resource is responsible for authorizing updates to a relationship? Should there be some unified way to describe it? Or is updating a user&#39;s posts an entirely separate operation from updating a post&#39;s user? Test authorization Support branching/more complicated control flow in authorization steps The Authorization flow for creates/updates may be insufficient. Instead of adding requests if relationships/attributes are changing, we may instead want to embed that knowledge inside the sat solver itself. Basically a relationship_foo_is_changing fact, anded with the resulting conditions. I&#39;m not even sure if thats possible though. Consider that authorization steps may eventually need to be able to branch. This may or may not be difficult :) Allow a feature called verify_after_write that fetches the final attribute variable from data somehow. Authorization fetchers will need to take state as an argument or something like that, and maybe need to specify dependencies?. Side load authorization testing Right now, includes will be generating their authorization facts independently. This is no great loss because anything that isn&#39;t data dependent should be a strict check anyway. However, we may at some point want to check to see if any filter exactly matches a side load filter, and authorize them together/have them share. Forbid impossible auth/creation situations (e.g &quot;the id field is not exposed on a create action, and doesn&#39;t have a default, therefore writes will always fail.) perhaps have auth steps express which fields need to be present, so we can avoid loading things unnecessarily check if preparations have been done on a superset filter of a request and, if so, use it just had a cool thought: we can actually run the satsolver before fetching the user. The satsolver could warn us early that no user could make the request in question! Use the sat solver at compile time to tell people when requests they&#39;ve configured (and maybe all combinations of includes they&#39;ve allowed?) couldn&#39;t possibly be allowed together. optimize authorization by allowing facts to be shared amongst requests? handle errors from runtime filtering based on authorizer responses Community twirp CI Add support for more elixir/erlang versions, add them to the CI matrix Relationships Flesh out relationship options most relationship stuff can&#39;t be done w/o primary keys Don&#39;t let users declare has_one relationships without claiming that there is a unique constraint on the destination field. Validate that all relationships on all resources in the API have destinations in that API, or don&#39;t and add in logic to pretend those don&#39;t exist through the API. validate reverse relationships!! document reverse relationships, or perhaps consider that we need a from_relationship filter instead? Factor out shared relationship options into its own schema, and merge them, for clearer docs. Naturally, only inner joins are allowed now. I think only inner joins will be necessary, as the pattern in ash would be to side load related data. Support arbitrary &quot;through&quot; relationships relationships updates are extremely unoptimized right now we don&#39;t support having duplicates in many_to_many relationships, so we&#39;ll need to document the limits around that: the primary key of the join resource must be (at least as it is in ash) the join keys. If they don&#39;t want to do that, then they should at a minimum define a unique constraint on the two join keys. relationship changes are an artifact of the old way of doing things and are very ugly right now Figure out under what circumstances we can bulk fetch when reading before updating many_to_many and to_many relationships, and do so. Perhaps, reverse relationships should eliminate the need to set destination field. also, perhaps, reverse relationships suck and should not be necessary. The alternative is a from_related filter, that lets you use an association in reverse allow configuring the name of the join relationship name for many to many relationships Primary Key So many parts of the system are reliant on things having an id key explicitly. THis will need to be addressed some day, and will be a huge pain in the ass Raise on composite primary key if data layer can&#39;t do it Params params should be solidified. Perhaps as a struct. Or perhaps just renamed to action_params where it is used. Consider making a &quot;params builder&quot; so you can say things like Ash.Params.add_side_load(params, [:foo, :bar, :baz]) and build params up over time. Validate that params on the way in are either all strings or all atoms Ecto The ecto internals that live on structs are going to cause problems w/ pluggability of backends, like the %Ecto.Association.NotLoaded{}. That backend may need to scrub the ecto specifics off of those structs. ETS make ets dep optional Unit test the Ets data layer Observability Use telemetry and/or some kind of hook system to add metrics Data Layer BIG: support transactions, both detecting that we are in a transaction and specifying a cross data-layer transaction Allow encoding database-level constraints into the resource, like &quot;nullable: false&quot; or something. This will let us validate things like not leaving orphans when bulk updating a many to many Eventually data_layers should state what raw types they support, and the filters they support on those raw types Think hard about the data_layer.can? pattern to make sure we&#39;re giving enough info, but not too much. Use data layer compatibility features to disallow incompatible setups. For instance, if the data layer can&#39;t transact, then they can&#39;t have an editable has_one or many_to_many resource. Add can?(:bulk_update) to data layers, so we can more efficiently update relationships Set up &quot;atomic updates&quot; (upserts). If an adapter supports them, and the auth passes precheck, we could turn get + update combos into upserts Make an automatic test suite that confirms that data layers behave the way they claim to behave, maybe. Is it possible/reasonable to do join tables that aren&#39;t unique on source_id/destination_id? Probably, but metadata would need to be organized differently. right now, we require the datalayer to support upserts in order to do relationship additions, but we could set it up such that if the datalayer doesn&#39;t support upserts, we first read the relationship. Its not airtight against race conditions (unless the datalayer supports transactions, also unimplemented) but its better than nothing. without transactions, we can&#39;t ensure that all changes are rolled back in the case that relationship updates are included. Don&#39;t think there is really anything to do about that, but something worth considering. DSL use a process to hold constructed DSL state, and then coalesce it all at the end. This can clean things up, and also allow us to potentially eliminate the registry. This will probably go hand in hand w/ the &quot;capabilities&quot; layer, where the DSL confirms that your data layer is capable of performing everything that your DSL declares Bake in descriptions to the DSL need to make sure that all of the dsl components are in the .formatter.exs. I made it so all of the options can be specified as a nested DSL, but haven&#39;t gone through and added them to the formatter file add init to checks, and error check their construction when building the DSL allow for resources to be created without the dsl Code Quality Replace all my ugly reduce with tuples with reduce_while Runtime Add a runtime-intialization to checks that can return data loading instructions to be executed prior to pre-check Important: We need a framework level solution for runtime configuration, or at minimum a recommended way to do it. Things like configuring the host/port of your API, or disabling features Testing talk about building factory/mocking utilities. I suspect mocking will not be necessary due to eventually being able to toggle resources to use the ETS datalayer. Engine implement transactions in the engine. Perhaps by assigning requests transaction ids or something along those lines. fix the comment noted in the destroy action: ~the delete needs to happen outside of the data fetching step, so the engine needs some kind of &quot;after data resolved&quot; capability~ add a total failure mode (since JSON API just fails entirely) that will cause the engine to stop on the first error Get rid of all of the :lists.droplast and List.first stuff by making a %Ash.Engine.Dependecy{path: path, field: field} consider (some day) opening up the engine/request as a public API Fields/Attributes Flesh out field options (sortable, filterable, other behavior?) Booleans need to not support nil values. That has to be a different type. boolean filter/authorization logic is greatly enhanced if that is the case. Add the ability to configure what fields can identify a user (for instance email) and use those in checks. certain attribute names are not going to be allowed, like or, and, in, things like that. Make sure updating foreign key attributes behaves the same as setting a relationship, or just disallow having editable attributes for relationship fkeys Framework support accepting a resource and a filter in api.update and api.destroy, and doing those as bulk actions support something similar to the older interface we had with ash, like Api.read(resource, filter: [...], sort: [...]), as the Ash.Query method is a bit long form in some cases Add a mixin compatibility checker framework, to allow for extensions to declare what features they do/don&#39;t support. Have ecto types ask the data layer about the kinds of filtering they can do, and that kind of thing. Make an Ash.Changeset that is a superset of an ecto changeset consider, just for the sake of good old fashion fun/cool factor, a parser that can parse a string into a query at compile time, so that queries can look nice in code. Make Ash.Type that is a superset of things like Ecto.Type. If we bring in ecto database-less(looking like more and more of a good idea to me) that kind of thing gets easier and we can potentially lean on ecto for type validations well. When we support embedding, figure out embed_as on Ash.Type Consider supporting one resource being a &quot;more specific&quot; version of another resource at the resource level, not the data layer level."},{"ref":"readme.html#creating-a-new-release-of-ash","title":"README - Creating a new release of Ash","type":"extras","doc":"check out the repository locally run mix git_ops.release (see git_ops documentation for more information) check the changelog/new release number push (with tags) and CI will automatically deploy the hex package"}]